package example;

import Log;
import junit.framework.*;
import junit.extensions.awt.*;
import java.io.File;
import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;
//import junit.textui.TestRunner;
//import junit.ui.TestRunner;
//import junit.swingui.TestRunner;

/** Simple example of AWTTestCase.  Selects all scripts of the form
 * MyCode-[0-9]*.xml. 
 */
public class MyCodeTest extends AWTTestCase {

    /** Name is the name of a script filename. */
    public MyCodeTest(String name) {
        super(name);
    }

    /** Return the set of scripts we want to run. */
    public static Test suite() {
        return new AWTTestSuite(MyCodeTest.class, "example") {
            /** Determine whether the given script should be included. */
            protected boolean accept(File file) {
                String name = file.getName();
                return name.startsWith("MyCode-") && name.endsWith(".xml");
            }
        };
    }

    public static void main(String[] args) {
        args = Log.init(args);
        String[] names = { MyCodeTest.class.getName() };
        if (args.length == 1 && args[0].equals("--gui"))
            junit.swingui.TestRunner.main(names);
        else
            junit.textui.TestRunner.main(names);
    }
}
