package test;

import Log;
import junit.extensions.awt.tester.*;
import junit.extensions.awt.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;

/** Unit test to verify the base ComponentTester class. */

public class ComponentTesterTest extends junit.framework.TestCase {

    /** Use the same finder for all tests. */
    private static ComponentFinder finder = new DefaultComponentFinder();
    /** Generic flag. */
    private boolean flag = false;
    private JFrame frame;
    private static final int TIMEOUT = 5000;

    /** Create a new test case with the given name. */
    public ComponentTesterTest(String name) {
        super(name);
    }

    protected void setUp() {
        flag = false;
        frame = new JFrame(getName());
        ((JPanel)frame.getContentPane()).setBorder(new EmptyBorder(50, 50, 50, 50));
    }

    protected void tearDown() {
        frame.dispose();
    }

    /** Test the component click action. */
    public void testClick() {
        JButton button = new JButton("Click here");
        button.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent ev) {
                flag = true;
            }
        });
        frame.getContentPane().add(button);
        frame.pack();
        frame.show();
        ComponentTester tester = finder.getTester(button);
        Timer timer = new Timer();
        while (!tester.assertFrameShowing(getName())) {
            if (timer.elapsed() > TIMEOUT) 
                fail("Frame never showed");
        }

        assertEquals(tester.deriveTag(button), button.getText());
        Dimension size = button.getSize();
        tester.actionClick(button, (size.width + 1)/2, (size.height + 1)/2);

        timer.reset();
        String details = "";
        if (System.getProperty("os.name").startsWith("Windows"))
            details = " (make sure your mouse pointer speed is set to the default (middle) and the buttons are set to right-handed)";
        while (!flag) {
            if (timer.elapsed() > TIMEOUT)
                fail("Button never clicked" + details);
        }
    }

    /** Provide a default test suite for this test case. */
    public static junit.framework.Test suite() {
        return new junit.framework.TestSuite(ComponentTesterTest.class);
    }

    public static void main(String[] args) {
        args = Log.init(args);
        String[] names = { ComponentTesterTest.class.getName() };
        if (args.length == 1 && args[0].equals("--gui"))
            junit.swingui.TestRunner.main(names);
        else
            junit.textui.TestRunner.main(names);
    }
}
